<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><link rel="canonical" href="https://gitlab.eclipse.org/eclipse/xfsc/xfsc-spec-2/notare/notare/" />
      <link rel="shortcut icon" href="../../img/favicon.ico" />
    <title>Notarization API Extension - XFSC-spec-2</title>
    <link rel="stylesheet" href="../../css/theme.css" />
    <link rel="stylesheet" href="../../css/theme_extra.css" />
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.8.0/styles/github.min.css" />
    
      <script>
        // Current page data
        var mkdocs_page_name = "Notarization API Extension";
        var mkdocs_page_input_path = "notare\\notare.md";
        var mkdocs_page_url = "/eclipse/xfsc/xfsc-spec-2/notare/notare/";
      </script>
    
    <!--[if lt IE 9]>
      <script src="../../js/html5shiv.min.js"></script>
    <![endif]-->
      <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.8.0/highlight.min.js"></script>
      <script>hljs.highlightAll();</script> 
</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side stickynav">
    <div class="wy-side-scroll">
      <div class="wy-side-nav-search">
          <a href="../.." class="icon icon-home"> XFSC-spec-2
        </a><div role="search">
  <form id ="rtd-search-form" class="wy-form" action="../../search.html" method="get">
      <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" title="Type search term here" />
  </form>
</div>
      </div>

      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../..">Index</a>
                </li>
              </ul>
              <ul class="current">
                <li class="toctree-l1 current"><a class="reference internal current" href="./">Notarization API Extension</a>
    <ul class="current">
    <li class="toctree-l2"><a class="reference internal" href="#1-introduction">1  Introduction</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#11-document-purpose">1.1  Document Purpose</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#12-product-scope">1.2  Product Scope</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#13-definitions-acronyms-and-abbreviations">1.3  Definitions, Acronyms and Abbreviations</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#14-references">1.4  References</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#15-document-overview">1.5  Document Overview</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#2-product-overview">2  Product Overview</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#21-product-perspective">2.1  Product Perspective</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#22-product-functions">2.2  Product Functions</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#33-product-constraints">3.3  Product Constraints</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#24-user-classes-and-characteristics">2.4  User Classes and Characteristics</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#25-operating-environment">2.5  Operating Environment</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#26-user-documentation">2.6  User Documentation</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#27-assumptions-and-dependencies">2.7  Assumptions and Dependencies</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#28-prioritization-of-system-features">2.8  Prioritization of System Features</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#3-requirements">3  Requirements</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#31-external-interfaces">3.1  External Interfaces</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#311-user-interfaces">3.1.1  User Interfaces</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#312-hardware-interfaces">3.1.2  Hardware Interfaces</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#313-software-interfaces">3.1.3  Software Interfaces</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#314-communications-interfaces">3.1.4  Communications Interfaces</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#32-functional">3.2  Functional</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#33-nonfunctional-requirements">3.3  Nonfunctional Requirements</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#331-http-requirements">3.3.1  HTTP Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#332-logging-requirements">3.3.2  Logging Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#333-performance-requirements">3.3.3  Performance Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#334-safety-requirements">3.3.4  Safety Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#335-security-requirements">3.3.5  Security Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#336-software-quality-attributes">3.3.6  Software Quality Attributes</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#337-business-rules">3.3.7  Business Rules</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#34-compliance">3.4  Compliance</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#35-design-and-implementation">3.5  Design and Implementation</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#351-installation">3.5.1  Installation</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#352-configuration">3.5.2  Configuration</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#353-distribution">3.5.3  Distribution</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#354-service-meshing">3.5.4  Service Meshing</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#355-standard-technology">3.5.5  Standard Technology</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#356-metrics">3.5.6  Metrics</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#357-configurability">3.5.7  Configurability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#358-maintainability">3.5.8  Maintainability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#359-reusability">3.5.9  Reusability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#3510-runtime-stability">3.5.10 Runtime Stability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#3511-high-availability-concepts">3.5.11 High Availability Concepts</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#3512-proof-of-concept">3.5.12 Proof of Concept</a>
    </li>
        </ul>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#4-verification">4  Verification</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#41-core-verification-requirements">4.1  Core Verification Requirements</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#42-support-for-kubernetes">4.2  Support for Kubernetes</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#43-functionality-acceptance-criteria">4.3  Functionality Acceptance Criteria</a>
    </li>
        </ul>
    </li>
    </ul>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../train/train/">Trust Management Infrastructure</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../ocme1/ocme1/">Organization Credential Manager Extension</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../ocmwstack/ocmwstack/">Organization Credential Manager W-STACK</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../pcmcloud/pcmcloud/">Cloud Personal Credential Manager</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../pcme1/pcme1/">Personal Credential Manager Extension 1</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../tsae1/tsae1/">Trust Services API Extension</a>
                </li>
              </ul>
      </div>
    </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
      <nav class="wy-nav-top" role="navigation" aria-label="Mobile navigation menu">
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../..">XFSC-spec-2</a>
        
      </nav>
      <div class="wy-nav-content">
        <div class="rst-content"><div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../.." class="icon icon-home" aria-label="Docs"></a></li>
      <li class="breadcrumb-item active">Notarization API Extension</li>
    <li class="wy-breadcrumbs-aside">
    </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
            <div class="section" itemprop="articleBody">
              
                <h2 id="software-requirements-specification-for-gaia-x-federation-services-notarization-api-extension-1cp-notare1">Software Requirements Specification  for  Gaia-X Federation Services Notarization API Extension 1CP.  NOTARE1</h2>
<p>Published by</p>
<p>eco -- Association of the Internet Industry (eco -- Verband der Internetwirtschaft e.V.) Lichtstrasse 43h 50825 Cologne, Germany</p>
<p>Copyright </p>
<p>© 2023 eco -- Association of the Internet Industry
This work is licensed under the Creative Commons attribution 4.0nInternational License. To view a copy of this license, visit <a href="http://creativecommons.org/licenses/by/4.0/">http://creativecommons.org/licenses/by/4.0/</a> or send a letter to Creative Commons, PO Box 1866, Mountain View, CA 94042, USA</p>
<p><img alt="" src="../media/image1.png" /></p>
<h4 id="1-introduction">1  <a href="#introduction">Introduction </a></h4>
<blockquote>
<h5 id="11-document-purpose">1.1  <a href="#document-purpose">Document Purpose </a></h5>
<h5 id="12-product-scope">1.2  <a href="#product-scope">Product Scope </a></h5>
<h5 id="13-definitions-acronyms-and-abbreviations">1.3  <a href="#definitions-acronyms-and-abbreviations">Definitions, Acronyms and Abbreviations</a></h5>
<h5 id="14-references">1.4  <a href="#references">References </a></h5>
<h5 id="15-document-overview">1.5  <a href="#document-overview">Document Overview </a></h5>
</blockquote>
<h4 id="2-product-overview">2  <a href="#product-overview">Product Overview </a></h4>
<blockquote>
<h5 id="21-product-perspective">2.1  <a href="#product-perspective">Product Perspective </a></h5>
<h5 id="22-product-functions">2.2  <a href="#product-functions">Product Functions </a></h5>
<h5 id="33-product-constraints">3.3  <a href="#product-constraints">Product Constraints </a></h5>
<h5 id="24-user-classes-and-characteristics">2.4  <a href="#user-classes-and-characteristics">User Classes and Characteristics</a></h5>
<h5 id="25-operating-environment">2.5  <a href="#operating-environment">Operating Environment </a></h5>
<h5 id="26-user-documentation">2.6  <a href="#user-documentation">User Documentation </a></h5>
<h5 id="27-assumptions-and-dependencies">2.7  <a href="#assumptions-and-dependencies">Assumptions and Dependencies </a></h5>
<h5 id="28-prioritization-of-system-features">2.8  <a href="#prioritization-of-system-features">Prioritization of System Features</a></h5>
</blockquote>
<h4 id="3-requirements">3  <a href="#requirements">Requirements </a></h4>
<blockquote>
<h5 id="31-external-interfaces">3.1  <a href="#external-interfaces">External Interfaces </a></h5>
<blockquote>
<h6 id="311-user-interfaces">3.1.1  <a href="#user-interfaces">User Interfaces </a></h6>
<h6 id="312-hardware-interfaces">3.1.2  <a href="#hardware-interfaces">Hardware Interfaces </a></h6>
<h6 id="313-software-interfaces">3.1.3  <a href="#software-interfaces">Software Interfaces </a></h6>
<h6 id="314-communications-interfaces">3.1.4  <a href="#communications-interfaces">Communications Interfaces </a></h6>
</blockquote>
<h5 id="32-functional">3.2  <a href="#functional">Functional </a></h5>
<h5 id="33-nonfunctional-requirements">3.3  <a href="#nonfunctional-requirements">Nonfunctional Requirements </a></h5>
<blockquote>
<h6 id="331-http-requirements">3.3.1  <a href="#http-requirements">HTTP Requirements </a></h6>
<h6 id="332-logging-requirements">3.3.2  <a href="#logging-requirements">Logging Requirements </a></h6>
<h6 id="333-performance-requirements">3.3.3  <a href="#performance-requirements">Performance Requirements </a></h6>
<h6 id="334-safety-requirements">3.3.4  <a href="#safety-requirements">Safety Requirements </a></h6>
<h6 id="335-security-requirements">3.3.5  <a href="#security-requirements">Security Requirements </a></h6>
<h6 id="336-software-quality-attributes">3.3.6  <a href="#software-quality-attributes">Software Quality Attributes</a></h6>
<h6 id="337-business-rules">3.3.7  <a href="#business-rules">Business Rules </a></h6>
</blockquote>
<h5 id="34-compliance">3.4  <a href="#compliance">Compliance </a></h5>
<h5 id="35-design-and-implementation">3.5  <a href="#design-and-implementation">Design and Implementation </a></h5>
<blockquote>
<h6 id="351-installation">3.5.1  <a href="#installation">Installation </a></h6>
<h6 id="352-configuration">3.5.2  <a href="#configuration">Configuration </a></h6>
<h6 id="353-distribution">3.5.3  <a href="#distribution">Distribution </a></h6>
<h6 id="354-service-meshing">3.5.4  <a href="#service-meshing">Service Meshing </a></h6>
<h6 id="355-standard-technology">3.5.5  <a href="#standard-technology">Standard Technology </a></h6>
<h6 id="356-metrics">3.5.6  <a href="#metrics">Metrics </a></h6>
<h6 id="357-configurability">3.5.7  <a href="#configurability">Configurability </a></h6>
<h6 id="358-maintainability">3.5.8  <a href="#maintainability">Maintainability </a></h6>
<h6 id="359-reusability">3.5.9  <a href="#reusability">Reusability </a></h6>
<h6 id="3510-runtime-stability">3.5.10 <a href="#runtime-stability">Runtime Stability </a></h6>
<h6 id="3511-high-availability-concepts">3.5.11 <a href="#high-availability-concepts">High Availability Concepts </a></h6>
<h6 id="3512-proof-of-concept">3.5.12 <a href="#proof-of-concept">Proof of Concept </a></h6>
</blockquote>
</blockquote>
<h4 id="4-verification">4  <a href="#verification">Verification </a></h4>
<blockquote>
<h5 id="41-core-verification-requirements">4.1  <a href="#core-verification-requirements">Core Verification Requirements</a></h5>
<h5 id="42-support-for-kubernetes">4.2  <a href="#support-for-kubernetes">Support for Kubernetes </a></h5>
<h5 id="43-functionality-acceptance-criteria">4.3  <a href="#functionality-acceptance-criteria">Functionality Acceptance Criteria</a></h5>
</blockquote>
<p><a href="#appendix-a-glossary">Appendix A: Glossary </a></p>
<p><a href="#appendix-b-architecture">Appendix B: Architecture </a></p>
<h1 id="list-of-figures">List of Figures</h1>
<blockquote>
<p>Figure 1: References </p>
<p>Figure 2: Cooperation View </p>
</blockquote>
<h1 id="list-of-tables">List of Tables</h1>
<blockquote>
<p>Table 1: User Classes </p>
<p>Table 2: Priorities </p>
<p>Table 3: Technology Stack </p>
</blockquote>
<h1 id="introduction">Introduction</h1>
<blockquote>
<p>To get general information regarding Gaia-X and the Gaia-X Federation Services please refer to [TAD] and [PRD].</p>
</blockquote>
<h2 id="document-purpose">Document Purpose</h2>
<blockquote>
<p>The purpose of the document is to specify the requirements of the Compliance subcomponent "Notarization API Extension 1" with the intention of an European wide public tender for implementing this software extension. Main audience for this document are attendees of the public tender, which are able to supply an open-source software solution for the area of identity and document verification with the purpose to provide digital support for existing certification bodies within Gaia-X.</p>
</blockquote>
<h2 id="product-scope">Product Scope</h2>
<blockquote>
<p>The product scope is to extend the existing component "Notarization API", with the following new features:</p>
</blockquote>
<ul>
<li>
<p>Protocol agnostic issuances depending on the incoming DID and format
    definitions</p>
</li>
<li>
<p>New issuance and verification protocols</p>
</li>
<li>
<p>Business validation flow for the notary</p>
</li>
<li>
<p>Documentation for using NOT as the compliance service for
    memberships</p>
</li>
<li>
<p>Dynamic schema configuration</p>
</li>
<li>
<p>Enrollment of organization to certain trustlists</p>
</li>
<li>
<p>Trust verification before the issuance process with the TRAIN module</p>
</li>
<li>
<p>Automatic Notarization Verification</p>
</li>
</ul>
<hr />
<blockquote>
<p><img alt="" src="../media/image2.png" /></p>
<p>The product extension must include interfaces (API's) to integrate the notarization component smoothly in external software for Non-IT operator usage (e.g., lawyers, notaries, governments, certifiers ...).
If it's required to do code restructurings, modifying the current solution by adding new microservices etc. then this is explicitly allowed.
Please note, that it is explicitly required to deliver the software up and running. Responsibility for existing code cannot be shifted to previous development teams.</p>
</blockquote>
<hr />
<h2 id="definitions-acronyms-and-abbreviations">Definitions, Acronyms and Abbreviations</h2>
<blockquote>
<p>Please refer to [IDM.AO] for Terminology/Glossary.</p>
</blockquote>
<h3 id="references">References</h3>
<table>
<thead>
<tr>
<th>Reference</th>
<th>Title</th>
<th>Link</th>
<th>Status</th>
</tr>
</thead>
<tbody>
<tr>
<td>[BDD]</td>
<td>Getting Started with Behavior Driven Development</td>
<td><a href="https://specflow.org/bdd/">Specflow</a></td>
<td>03-18-2023</td>
</tr>
<tr>
<td>[CloudEvents]</td>
<td>CloudEvents Specification</td>
<td><a href="https://cloudevents.io/">cloudevents.io</a></td>
<td>03-17-2023</td>
</tr>
<tr>
<td>[IDM.AO]</td>
<td>Architecture Overview</td>
<td>Please refer to "annex_IDM.AO"</td>
<td></td>
</tr>
<tr>
<td>[IDM.TRAIN]</td>
<td>GXFS Trust Management Infrastructure</td>
<td>Please refer to "annex_IDM.TRAIN"</td>
<td></td>
</tr>
<tr>
<td>[OpenID VCI]</td>
<td>OpenID for Verifiable Credential Issuance</td>
<td><a href="https://openid.net/specs/openid-4-verifiable-credential-issuance-1_0.html">OpenID VCI Spec</a></td>
<td>03-18-2023</td>
</tr>
<tr>
<td>[OpenID VP]</td>
<td>OpenID for Verifiable Presentations</td>
<td><a href="https://openid.net/specs/openid-4-verifiable-presentations-1_0.html">OpenID VP Spec</a></td>
<td>03-18-2023</td>
</tr>
<tr>
<td>[PRD]</td>
<td>Gaia-X Policy Rules Document</td>
<td><a href="https://docs.gaia-x.eu/policy-rules-committee/policy-rules-labelling/22.11/">Gaia-X PRD</a></td>
<td>08-01-2023</td>
</tr>
<tr>
<td>[RFC2119]</td>
<td>Key words for use in RFCs to Indicate Requirement Levels</td>
<td><a href="https://tools.ietf.org/html/rfc2119">RFC 2119</a></td>
<td>07-04-2023</td>
</tr>
<tr>
<td>[TAD]</td>
<td>Gaia-X Architecture Document</td>
<td><a href="https://docs.gaia-x.eu/technical-committee/architecture-document/22.10/">Gaia-X TAD</a></td>
<td></td>
</tr>
</tbody>
</table>
<blockquote>
<h6 id="figure-1-references">Figure 1: References</h6>
</blockquote>
<h2 id="document-overview">Document Overview</h2>
<blockquote>
<p>The document describes the product perspective, functions, and constraints. It furthermore lists the functional and non-functional requirements and defines the system features in detail. The listed requirements are binding. Requirements as an expression of normative specifications are identified by a unique ID in square brackets (e.g. <strong>[CP.NOTAR.Number]</strong>) and the keywords MUST, MUST NOT, SHOULD, SHOULD NOT, MAY, corresponding to RFC 2119 [<a href="https://tools.ietf.org/html/rfc2119">RFC 2119</a>], are written in capital letters (see also [IDM.AO]-   Methodology).</p>
</blockquote>
<h1 id="product-overview">Product Overview</h1>
<h2 id="product-perspective">Product Perspective</h2>
<blockquote>
<p>The purpose of this product extension is to support the trust establishment with new enrollment processes. To reach this goal the software component extension should follow standard formats of credential exchange and enrollment. Therefore, this extension introduces new components. The following problems are being addressed with this extension:</p>
</blockquote>
<ul>
<li>
<p>Interoperability with other ecosystems &amp; future technology</p>
</li>
<li>
<p>Trust anchor enrollment</p>
</li>
<li>
<p>Trust verification</p>
</li>
</ul>
<blockquote>
<p>This allows each federation to create and host their own trust anchors and policies. Next to that they can choose between multiple ecosystems. The trust verification module with TRAIN allows the relying parties to verify trust chains more easily before issuing respective certificates.</p>
</blockquote>
<hr />
<blockquote>
<p><img alt="" src="../media/image2.png" /></p>
<p>The existing code base [1] MUST be reused and further improved. Other microservices MAY have different languages and architectures.</p>
</blockquote>
<h6 id="1-httpsgitlabeclipseorgeclipsexfscnot">[1] <a href="https://gitlab.eclipse.org/eclipse/xfsc/not"><u>[https://gitlab.eclipse.org/eclipse/xfsc/not]</u></a></h6>
<hr />
<h2 id="product-functions">Product Functions</h2>
<blockquote>
<p>The product extension itself follows the microservice component design principles. The functionality is exposed per REST Service and accessible over the Network per HTTPS protocol. The component has to be installed in multi locations and SHOULD NOT be planned as a central hosted system. Therefore, it must be possible to install it within the issuer's organization domain with multiuser access capabilities. The access to the offered functionality of the component extension MUST be protected for the usage in such an environment. This includes role concepts, data storage protection and access control. The overall functionality of the product MUST be auditable (GDPR conform), which means each action MUST be documented with all context-specific information within the system.</p>
<p>The main functionality scope of this product extension is to provide a way to enroll new issuers considering the defined policies of the Trust Framework [2] and the federation itself. It also allows Business owners to use different did-methods and be part of other ecosystems. That means each federation can create their own rulebook and allow their own ecosystems.</p>
<p>The core functions of the product extension are:</p>
</blockquote>
<ul>
<li>
<p>Enrollment of new issuers and authorities</p>
</li>
<li>
<p>TRAIN validation &amp; verification [3] [IDM.TRAIN]</p>
</li>
<li>
<p>DID method abstraction</p>
</li>
<li>
<p>Credential issuance &amp; verification</p>
</li>
<li>
<p>Automated external business validations</p>
</li>
</ul>
<p><img alt="" src="../media/image3.png" /></p>
<blockquote>
<h5 id="figure-2-cooperation-view">Figure 2: Cooperation View</h5>
<hr />
</blockquote>
<h6 id="2-httpsdocsgaia-xeupolicy-rules-committeetrust-framework2210participant">[2] <a href="https://docs.gaia-x.eu/policy-rules-committee/trust-framework/22.10/participant/"><u>[https://docs.gaia-x.eu/policy-rules-committee/trust-framework/22.10/participant/]</u></a></h6>
<h6 id="3httpsgitlabgrnetgressif-labinfrastructurefraunhofer">[3]<a href="https://gitlab.grnet.gr/essif-lab/infrastructure/fraunhofer"><u>[https://gitlab.grnet.gr/essif-lab/infrastructure/fraunhofer]</u></a></h6>
<h2 id="product-constraints">Product Constraints</h2>
<h5 id="cpnotare100000-the-document-idmao-and-core-credential-document">[CP.NOTAR.E1.00000] The document IDM.AO and Core Credential Document</h5>
<blockquote>
<p>The architecture document [IDM.AO] is an essential part of this
specification and a prerequisite for understanding the context. The
specifications and requirements from the Architecture Document MUST be
taken into account during implementation.</p>
</blockquote>
<h5 id="cpnotare100001-the-product-extension-architecture-pattern">[CP.NOTAR.E1.00001] The product extension architecture pattern</h5>
<blockquote>
<p>The product extension MUST follow the existing architecture pattern of
the first version (see Appendix B). It MUST enhance the existing
component with additional and missing features.</p>
</blockquote>
<h2 id="user-classes-and-characteristics">User Classes and Characteristics</h2>
<table>
<thead>
<tr>
<th>User Class</th>
<th>Description</th>
<th>Frequency</th>
<th>Expertise</th>
<th>Privilege Level</th>
<th>Product Usage</th>
</tr>
</thead>
<tbody>
<tr>
<td>Notarization Operator</td>
<td>Notarizes given data and confirms the issuing of electronic credentials to a given DID. An operator is an employee of the notarization office.</td>
<td>High</td>
<td>Low</td>
<td>High</td>
<td>Managing Frontend</td>
</tr>
<tr>
<td>Administrator</td>
<td>Sets up the system and maintains operator identities.</td>
<td>Low</td>
<td>High</td>
<td>Low</td>
<td>Backend Maintenance</td>
</tr>
<tr>
<td>Organization Business Owner / Authorization Officer</td>
<td>Represents a participant.</td>
<td>Low</td>
<td>Low</td>
<td>Low</td>
<td>Request Frontends</td>
</tr>
</tbody>
</table>
<blockquote>
<h6 id="table-1-user-classes">Table 1: User Classes</h6>
</blockquote>
<h2 id="operating-environment">Operating Environment</h2>
<h5 id="cpnotare100002-kubernetes-environment">[CP.NOTAR.E1.00002] Kubernetes Environment</h5>
<blockquote>
<p>The product MUST be operable on standard Kubernetes based environments
without any hardware restrictions. The reference environment for
demonstration and development purposes MUST be on a SCS cluster
(Sovereign Cloud Stack), that will be provided by the Principal. </p>
</blockquote>
<h5 id="cpnotare100003-tls-protected-endpoints">[CP.NOTAR.E1.00003] TLS Protected Endpoints</h5>
<blockquote>
<p>To protect the product endpoint(s), it's necessary to support a
network infrastructure e.g., load balancers/proxies which MUST support
TLS encryption. The encryption MUST meet the requirements listed in
the chapter for security requirements. </p>
</blockquote>
<h2 id="user-documentation">User Documentation</h2>
<h5 id="cpnotare100004-participant-administration-documentation">[CP.NOTAR.E1.00004] Participant Administration Documentation</h5>
<blockquote>
<p>The documentation MUST contain:</p>
</blockquote>
<ul>
<li>
<p>Installation Manuals</p>
</li>
<li>
<p>Cryptographic Initialization (if applicable)</p>
</li>
<li>
<p>Description of Deployment/Compile Process</p>
</li>
<li>
<p>Description of the Automatic Tests / Verification</p>
</li>
<li>
<p>How to build the products from source code </p>
</li>
</ul>
<h5 id="cpnotare100006-participant-documentation">[CP.NOTAR.E1.00006] Participant Documentation</h5>
<blockquote>
<p>The documentation MUST contain:</p>
</blockquote>
<ul>
<li>
<p>Short Software Description (why and for what, when to use, how to
    use, where to use)</p>
</li>
<li>
<p>Usage guide</p>
</li>
<li>
<p>GDPR design decisions</p>
</li>
<li>
<p>Security concept</p>
</li>
<li>
<p>Operations concept</p>
</li>
<li>
<p>FAQ</p>
</li>
<li>
<p>Keyword Directory </p>
</li>
</ul>
<h2 id="assumptions-and-dependencies">Assumptions and Dependencies</h2>
<h5 id="cpnotare100007-train-dependencies">[CP.NOTAR.E1.00007] TRAIN Dependencies</h5>
<blockquote>
<p>The product extension has multiple dependencies to the TRAIN module
[IDM.TRAIN]. The following parts of the product extension have a
close relationship with the TRAIN module:</p>
</blockquote>
<ul>
<li>
<p>Enrollment of new issuers</p>
</li>
<li>
<p>Verification of verifiable presentations</p>
</li>
</ul>
<h2 id="prioritization-of-system-features">Prioritization of System Features</h2>
<table>
<thead>
<tr>
<th>Feature</th>
<th>Priority</th>
</tr>
</thead>
<tbody>
<tr>
<td>Enrollment of new issuers and authorities</td>
<td>1</td>
</tr>
<tr>
<td>TRAIN validation &amp; verification</td>
<td>1</td>
</tr>
<tr>
<td>DID method abstraction</td>
<td>2</td>
</tr>
<tr>
<td>Credential issuance &amp; verification flow</td>
<td>1</td>
</tr>
<tr>
<td>Automated external business validations</td>
<td>2</td>
</tr>
</tbody>
</table>
<h6 id="table-2-priorities">Table 2: Priorities</h6>
<hr />
<p><img alt="" src="../media/image2.png" /></p>
<blockquote>
<p>Please be aware that extending or contributing to the used frameworks means explicitly to actively make changes if necessary.</p>
</blockquote>
<hr />
<h1 id="requirements">Requirements</h1>
<h2 id="external-interfaces">External Interfaces</h2>
<h3 id="user-interfaces">User Interfaces</h3>
<blockquote>
<p>The User Interface functionality MUST be provided to the Command Line Interface (CLI) implementers.</p>
</blockquote>
<h3 id="hardware-interfaces">Hardware Interfaces</h3>
<blockquote>
<p>Not applicable.</p>
</blockquote>
<h3 id="software-interfaces">Software Interfaces</h3>
<h5 id="cpnotare100008-oauth2">[CP.NOTAR.E1.00008] OAuth2</h5>
<blockquote>
<p>The product internal IAM MUST support OAuth2 to grant access to the API. The product MUST be able to support the Identity Provider withinthe integration cluster.</p>
</blockquote>
<hr />
<p><img alt="" src="../media/image2.png" /></p>
<blockquote>
<p>The roles used for the profile
entitlement MUST be decoupled from the profile name.</p>
</blockquote>
<hr />
<h5 id="cpnotare100009-database-connection">[CP.NOTAR.E1.00009] Database Connection</h5>
<blockquote>
<p>The connection of the product to its database MUST be TLS encrypted or a similar encryption of the transport level. </p>
</blockquote>
<h3 id="communications-interfaces">Communications Interfaces</h3>
<h5 id="cpnotare100010-eventing">[CP.NOTAR.E1.00010] Eventing</h5>
<blockquote>
<p>If it is required to use events within the software architecture, it is mandatory to use software abstraction according to cloud event specification [CloudEvents] for publishing and subscription. The minimal supported protocol binding MUST be HTTPS Protocol Binding [5].</p>
</blockquote>
<h6 id="5-httpsgithubcomcloudeventsspecblobv102cloudeventsbindingshttp-protocol-bindingmd">[5] <a href="https://github.com/cloudevents/spec/blob/v1.0.2/cloudevents/bindings/http-protocol-binding.md"><u>[https://github.com/cloudevents/spec/blob/v1.0.2/cloudevents/bindings/http-protocol-binding.md]</u></a></h6>
<h5 id="cpnotare100011-eventing-infrastructure">[CP.NOTAR.E1.00011] Eventing Infrastructure</h5>
<blockquote>
<p>The event broker for the eventing MUST abstract the storage and delivery infrastructure. In Kubernetes environments, the event broker MUST be uniform across all Lots by using NATS[6] and/or kNative.</p>
</blockquote>
<h6 id="6-httpsnatsio">[6] <a href="https://nats.io/"><u>[https://nats.io/]</u></a></h6>
<h5 id="cpnotare100012-notarization-request-endpoint">[CP.NOTAR.E1.00012] Notarization Request Endpoint</h5>
<blockquote>
<p>The existing request endpoint MUST be enhanced with a new functionality to request a DID enrollment for a trustlist. The functionality of this enhancement is described in chapter 3.2 [CP.NOTAR.E.1.000014]</p>
<p>Supported Actions: GET (view), POST (Notarization Request), PATCH (update existing Request), DELETE (Revoke existing Request) and POST for File Upload.</p>
</blockquote>
<h2 id="functional">Functional</h2>
<h5 id="cpnotare100014-enrollment-of-new-issuers-and-authorities">[CP.NOTAR.E1.00014] Enrollment of new issuers and authorities</h5>
<h6 id="description"><i> Description </i></h6>
<blockquote>
<p>The enrollment process of new issuers is a process to set a DID and the respective configuration on a trustlist of a federation. This process can be started with the request endpoint and MUST be defined with one attribute. The request of the enrollment MUST follow the same flow as any other request.</p>
<p>After the confirmation of the request from the notary the action / output MUST be a new entry on an existing trustlist. To add an entry on the trustlist the TRAIN enrollment module needs to be called.</p>
</blockquote>
<h6 id="constraints"><i> Constraints </i></h6>
<ul>
<li>
<p>Own DID for issuing.</p>
</li>
<li>
<p>DID of the organization.</p>
</li>
<li>
<p>Database system.</p>
</li>
</ul>
<h6 id="interfaces"><i> Interfaces </i></h6>
<ul>
<li>
<p>TRAIN enrollment module.</p>
</li>
<li>
<p>Database interface.</p>
</li>
</ul>
<h6 id="input"><i> Input </i></h6>
<blockquote>
<p>A confirmed request record. This needs to include:</p>
</blockquote>
<ul>
<li>
<p>DID of the organization</p>
</li>
<li>
<p>ID of the trust list</p>
</li>
<li>
<p>ID of the schema</p>
</li>
<li>
<p>Metadata of the entity (to be specified further according to
    business analyst analysis)</p>
<ul>
<li>
<p>Legal Name</p>
</li>
<li>
<p>Certification details</p>
</li>
<li>
<p>Assurance Levels</p>
</li>
</ul>
</li>
<li>
<p>Types of DIDs supported</p>
</li>
<li>
<p>Type of other digital credentials supported (example: x509)</p>
</li>
<li>
<p>Different services offered by the organization</p>
</li>
</ul>
<h6 id="output"><i> Output </i></h6>
<ul>
<li>A new entry in an existing trust list.</li>
</ul>
<h6 id="acceptance-criteria"><i> Acceptance Criteria </i></h6>
<ol>
<li>
<p>DID of the request successfully added to the trustlist.</p>
</li>
<li>
<p>The requestor is able to issue the VC mentioned on the trustlist.</p>
</li>
</ol>
<h5 id="cpnotare100015-train-validation-verification">[CP.NOTAR.E1.00015] TRAIN validation &amp; verification</h5>
<h6 id="description_1"><i> Description </i></h6>
<blockquote>
<p>The TRAIN validation service needs to be included in the process of verifying a verifiable presentation. If a requestor is showing a verifiable presentation during a task which needs to be fulfilled, the notarization service needs to validate the terms Of Use by calling the TRAIN validation module [IDM.TRAIN.00017]. This will verify if the shown verifiable presentation and the respective owner of it is on a trust list.</p>
</blockquote>
<h6 id="constraints_1"><i> Constraints </i></h6>
<ul>
<li>
<p>DID of the organization.</p>
</li>
<li>
<p>Database system.</p>
</li>
</ul>
<h6 id="interfaces_1"><i> Interfaces </i></h6>
<ul>
<li>TRAIN validation module.</li>
</ul>
<h6 id="input_1"><i> Input </i></h6>
<ul>
<li>A verification with an incoming verifiable presentation.</li>
</ul>
<h6 id="output_1"><i> Output </i></h6>
<ul>
<li>Verification output of the TRAIN validation module.</li>
</ul>
<h6 id="acceptance-criterias"><i> Acceptance Criterias </i></h6>
<ol>
<li>
<p>The terms Of Use could successfully be verified and validated.</p>
</li>
<li>
<p>The presentation could successfully be proved cryptographically and
    semantically.</p>
</li>
</ol>
<h5 id="cpnotare100016-did-method-abstraction">[CP.NOTAR.E1.00016] DID method abstraction</h5>
<h6 id="description_2"><i> Description </i></h6>
<blockquote>
<p>The SSI Issuance controller MUST be able to understand multiple DID methods and MUST also issue the Credential in the respective issuance protocol. The focus MUST lay on the DID methods EBSI, Sovrin (Indy), Web and Key. The notarization service MUST be enhanced with a connection to the EBSI ledger. Depending on the incoming request the SSI Issuance service MUST decide which credential exchange protocol [CP.NOTAR.00022] should be used. The selection of which one must be used depends on which service endpoint is available on the DID document of the requestor. The DID:Web method MUST be configurable for issuing credentials.</p>
</blockquote>
<h6 id="constraints_2"><i> Constraints </i></h6>
<ul>
<li>
<p>DID of the organization.</p>
</li>
<li>
<p>Database system.</p>
</li>
<li>
<p>CP.NOTAR.00022 credential issuance extension</p>
</li>
</ul>
<h6 id="interfaces_2"><i> Interfaces </i></h6>
<ul>
<li>
<p>Database interface.</p>
</li>
<li>
<p>Issuance Endpoint</p>
</li>
</ul>
<h6 id="input_2"><i> Input </i></h6>
<ul>
<li>
<p>Request from the request endpoint.</p>
</li>
<li>
<p>DID of the organization.</p>
</li>
</ul>
<h6 id="output_2"><i> Output </i></h6>
<blockquote>
<p>/</p>
</blockquote>
<h6 id="acceptance-criterias_1"><i> Acceptance Criterias </i></h6>
<blockquote>
<ol>
<li>Successful managed request.</li>
</ol>
</blockquote>
<h5 id="cpnotare100017-credential-issuing-extension">[CP.NOTAR.E1.00017] Credential Issuing extension</h5>
<h6 id="description_3"><i> Description </i></h6>
<blockquote>
<p>The existing SSI issuance service needs to be enhanced with a new protocol to issue verifiable credentials. If a DID supports the respective endpoint the issuance service should use the OpenID for Verifiable credential issuance protocol [OpenID VCI] and the component can perform a Present Proof request before issuing defined in OpenID for Verifiable Presentations [OpenID VP]. The credential issuing is an asynchronous process which checks the database for confirmed request records in the database. All of the found confirmed records will be picked up. Within the record MUST be a linked DID of the participant, which is here used to establish a connection to the Credential Manager (OCM and PCM) of the participant.</p>
</blockquote>
<h6 id="constraints_3"><i> Constraints </i></h6>
<ul>
<li>
<p>Own DID for issuing.</p>
</li>
<li>
<p>DID of the organization.</p>
</li>
<li>
<p>Database system.</p>
</li>
<li>
<p>OpenID for Verifiable credential issuance.</p>
</li>
<li>
<p>OpenID for Verifiable Presentations</p>
</li>
</ul>
<h6 id="interfaces_3"><i> Interfaces </i></h6>
<ul>
<li>
<p>Database interface.</p>
</li>
<li>
<p>Issue Endpoint.</p>
</li>
</ul>
<h6 id="input_3"><i> Input </i></h6>
<ul>
<li>A confirmed request record.</li>
</ul>
<h6 id="output_3"><i> Output </i></h6>
<ul>
<li>An issued credential to the participant DID.</li>
</ul>
<h6 id="acceptance-criteria_1"><i> Acceptance Criteria </i></h6>
<ol>
<li>
<p>Credential successfully issued to participant DID.</p>
</li>
<li>
<p>Credential has the exact type of the request context.</p>
</li>
<li>
<p>Deletion of the request record, after successful issuing.</p>
</li>
</ol>
<h5 id="cpnotare100018-proof-of-credentials-extension">[CP.NOTAR.E1.00018] Proof of Credentials extension</h5>
<h6 id="description_4"><i> Description </i></h6>
<blockquote>
<p>To prove the trustworthiness of this product extension, it MUST support the OpenID for Verifiable Presentations and it MUST be configurable which proofs are fulfilled automatically (e.g., based on a configured schema). If a DID supports the respective endpoint, the SSI service should use the OpenID for Verifiable presentations protocol. In the case of a JSON-LD Presentation an extended validation MUST be supported via TRAIN [IDM.TRAIN]. After the cryptographic proofing the semantic validation MUST happen via TRAIN. This SHOULD validate the Trust against the Trust Framework and registries.</p>
</blockquote>
<h6 id="constraints_4"><i> Constraints </i></h6>
<ul>
<li>
<p>Control over the Own DID.</p>
</li>
<li>
<p>OpenID for Verifiable presentations protocol.</p>
</li>
<li>
<p>TRAIN.</p>
</li>
</ul>
<h6 id="interfaces_4"><i> Interfaces </i></h6>
<ul>
<li>
<p>Issue Endpoint</p>
</li>
<li>
<p>TRAIN</p>
</li>
</ul>
<h6 id="input_4"><i> Input </i></h6>
<ul>
<li>Any presentation request described in OpenID for Verifiable
    Presentations.</li>
</ul>
<h6 id="output_4"><i> Output </i></h6>
<ul>
<li>A presentation request according to OpenID for Verifiable
    Presentations.</li>
</ul>
<h6 id="acceptance-criteria_2"><i> Acceptance Criteria </i></h6>
<blockquote>
<ol>
<li>The Software is able to prove the credentials of the holder.</li>
</ol>
</blockquote>
<h5 id="cpnotare100019-external-business-validations">[CP.NOTAR.E1.00019] External business validations</h5>
<h6 id="description_5"><i> Description </i></h6>
<blockquote>
<p>The notarization administrator MUST have the possibility to add an external business validation. This MUST be an API GET request to an external system to fetch data. Next to that the service needs to validate the fetched data and include them in the issuance process. The verification process should include the Gaia-X compliance service [7] to make additional checks.</p>
</blockquote>
<h6 id="7-httpsgitlabcomgaia-xlabcompliancegx-compliance">[7] <a href="https://gitlab.com/gaia-x/lab/compliance/gx-compliance"><u>[https://gitlab.com/gaia-x/lab/compliance/gx-compliance]</u></a></h6>
<h6 id="constraints_5"><i> Constraints </i></h6>
<ul>
<li>
<p>DID of the organization.</p>
</li>
<li>
<p>Database system.</p>
</li>
<li>
<p>OpenID for Verifiable credential issuance.</p>
</li>
</ul>
<h6 id="interfaces_5"><i> Interfaces </i></h6>
<blockquote>
<p>/</p>
</blockquote>
<h6 id="input_5"><i> Input </i></h6>
<ul>
<li>A confirmed request record.</li>
</ul>
<h6 id="output_5"><i> Output </i></h6>
<ul>
<li>Validated data from an external system.</li>
</ul>
<h6 id="acceptance-criterias_2"><i> Acceptance Criterias </i></h6>
<ol>
<li>
<p>External data successfully fetched</p>
</li>
<li>
<p>External data successfully verified</p>
</li>
</ol>
<h5 id="cpnotare100020-cloud-configuration">[CP.NOTAR.E1.00020] Cloud Configuration</h5>
<blockquote>
<p>The provider MUST support advanced cloud configuration by using Kubernetes config maps provided by HELM templates. Additionally, the provider MUST accept dynamic configuration changes over the configuration UI.</p>
</blockquote>
<h5 id="cpnotare100021-dynamic-schema-profile-configuration">[CP.NOTAR.E1.00021] Dynamic schema (profile) configuration</h5>
<blockquote>
<p>The software extension MUST include dynamic schema configuration. For now, the credential schemas (profiles) can only be configured before starting the service. The software extension MUST include a dynamic schema configuration at run time. That means an endpoint needs to be created which can only be used by the admin of the software or the enabled notaries. For the generation of the profile the component IDM.SR should be used. Based on the different Trust anchor and credential format of the profile the schema regeneration should follow a different flow. The following schema generation flows MUST be supported:</p>
</blockquote>
<ul>
<li>
<p>EBSI schema generation with the Trusted Schemas Registry fromb EBSI[8]</p>
</li>
<li>
<p>IDUnion (Indy) credential schema creation and credential definition</p>
</li>
<li>
<p>JSON-LD schema context generation and storage on IPFS</p>
</li>
</ul>
<h6 id="8-httpsapi-pilotebsieudocsapistrusted-schemas-registrylatest">[8] <a href="https://api-pilot.ebsi.eu/docs/apis/trusted-schemas-registry/latest#/"><u>[https://api-pilot.ebsi.eu/docs/apis/trusted-schemas-registry/latest#/]</u></a></h6>
<h6 id="constraints_6"><i> Constraints </i></h6>
<ul>
<li>
<p>Attributes of the schema</p>
</li>
<li>
<p>Database system</p>
</li>
</ul>
<h6 id="interfaces_6"><i> Interfaces </i></h6>
<blockquote>
<p>Interface to IDM.SR</p>
</blockquote>
<h6 id="input_6"><i> Input </i></h6>
<ul>
<li>
<p>Schema attributes</p>
</li>
<li>
<p>Trustanchor</p>
</li>
<li>
<p>VC Format</p>
</li>
<li>
<p>Issuer DID</p>
</li>
</ul>
<h6 id="output_6"><i> Output </i></h6>
<ul>
<li>
<p>Created profile</p>
</li>
<li>
<p>Registered (stored) schema</p>
</li>
</ul>
<h6 id="acceptance-criterias_3"><i> Acceptance Criterias </i></h6>
<ol>
<li>Company data successfully validated</li>
</ol>
<h5 id="cpnotare100022-credential-issuance">[CP.NOTAR.E1.00022] Credential Issuance</h5>
<blockquote>
<p>When a DID Document provides multiple Communication protocols like OIDC4VC, Indy AIP 1.0 and AIP 2.0, the notarization API MUST issue a credential to all of the protocols, to have a consistent set of credentials in all wallets of the user.</p>
</blockquote>
<h5 id="cpnotare100023-role-management-cpnotare100023-role-management-unnumbered">[CP.NOTAR.E1.00023] Role Management {#cp.notar.e1.00023-role-management .unnumbered}</h5>
<blockquote>
<p>The profiles MUST be decoupled from roles to allow and flexible management.</p>
</blockquote>
<h5 id="cpnotare100024-swagger-documentation">[CP.NOTAR.E1.00024] Swagger Documentation</h5>
<blockquote>
<p>The swagger documentation MUST be in the provided GitLab repository.</p>
</blockquote>
<h5 id="cpnotare100025-existing-schemas-as-template">[CP.NOTAR.E1.00025] Existing Schemas as Template</h5>
<blockquote>
<p>The profile Template collects attributes for issuing a credential, but existing schemas e.g., indy schemas should be accepted as well as template.</p>
</blockquote>
<h5 id="cpnotare100026-oaw-integration">[CP.NOTAR.E1.00026] OAW Integration</h5>
<blockquote>
<p>The API MUST be accessible for external services like OAW to support the automatic notarization and verification.</p>
</blockquote>
<h5 id="cpnotare100027-automatic-rule-based-notarization">[CP.NOTAR.E1.00027] Automatic rule-based Notarization</h5>
<blockquote>
<p>The API MUST support an automatic notarization functionality with usage of TSA Policies [9].</p>
</blockquote>
<h6 id="9-httpsgitlabeclipseorgeclipsexfsctsapolicies">[9] <a href="https://gitlab.eclipse.org/eclipse/xfsc/tsa/policies"><u>[https://gitlab.eclipse.org/eclipse/xfsc/tsa/policies]</u></a></h6>
<h5 id="cpnotare100028-revocation-preparation">[CP.NOTAR.E1.00028] Revocation Preparation</h5>
<blockquote>
<p>Additionally, the component MUST prepare an hash-based revocation which is calculated over the proof of the credential in the following way:</p>
</blockquote>
<ul>
<li>
<p>For RSA signature a SHA256 hash is calculated over the entire signature in raw byte format</p>
</li>
<li>
<p>For EC-DSA Signature the SHA256 hash is calculated over the r value of the proof signature</p>
</li>
</ul>
<blockquote>
<p>The revocation endpoint MUST provide this calculated hash of W3C credentials[10] to an internal storage grouped by Holder DID which has an internal interface to read the hashes for later integration (later integration is out of scope for this tender).</p>
</blockquote>
<h6 id="10-httpswwww3orgtrvc-data-model">[10] <a href="https://www.w3.org/TR/vc-data-model/"><u>[https://www.w3.org/TR/vc-data-model/]</u></a></h6>
<h2 id="nonfunctional-requirements">Nonfunctional Requirements</h2>
<h4 id="http-requirements">HTTP Requirements</h4>
<h5 id="cpnotare100029-https">[CP.NOTAR.E1.00029] HTTPS</h5>
<blockquote>
<p>All HTTP Endpoints MUST be protected by TLS 1.2 (all protocol version numbers SHOULD be superseded by upcoming standards). Each endpoint of the product MUST support TLS certificates which are configurable by the administrator of the system.</p>
</blockquote>
<h5 id="cpnotare100030-http-protocol-definitions">[CP.NOTAR.E1.00030] HTTP Protocol Definitions</h5>
<blockquote>
<p>All HTTP Endpoints MUST follow <a href="https://datatracker.ietf.org/doc/html/rfc7231">[RFC7231]</a> and <a href="https://datatracker.ietf.org/doc/html/rfc5789">[RFC5789],</a> but it MAY be chosen what of the protocols is necessary to realize the functionality. For problem reports the <a href="https://datatracker.ietf.org/doc/html/rfc7807">[RFC7807]</a> MUST be used in combination with Standard HTTP Error Codes.</p>
</blockquote>
<h3 id="logging-requirements">Logging Requirements</h3>
<h5 id="cpnotare100031-data-minimization">[CP.NOTAR.E1.00031] Data Minimization</h5>
<blockquote>
<p>The data minimization principle is expressed in Article 5(1)(c) of the GDPR and Article 4(1)(c) of Regulation (EU) 2018/1725, which provide that personal data must be \"adequate, relevant and limited to what is necessary in relation to the purposes for which they are processed\". The data shall be stored for a period of time in accordance with national requirements and, as a minimum, shall consist of thefollowing elements:</p>
</blockquote>
<p>a.  node\'s identification</p>
<p>b.  message identification</p>
<p>c.  message data and time</p>
<blockquote>
<p>All logged data/information MUST be documented in the GDPR design decisions for a GDPR review. </p>
</blockquote>
<h5 id="cpnotare100032-logging-frameworks">[CP.NOTAR.E1.00032] Logging Frameworks</h5>
<blockquote>
<p>The product MUST support logging frameworks e.g., graylog, fluentD or logstash to support logging and analysis by enterprise infrastructures. The supported framework MAY be chosen for the first version, but it MUST support potentially the most common open-source logging solutions. The final solution MUST be aligned with the other subcomponents. It MUST be sketched in the operations concept how the support of multiple solutions is given in the future. </p>
</blockquote>
<h3 id="performance-requirements">Performance Requirements</h3>
<h5 id="cpnotare100033-updown-scale">[CP.NOTAR.E1.00033] Up/Down Scale</h5>
<blockquote>
<p>All components MUST be able to scale up/down their functionality for undefined amount instances. This requires a parallel execution possibility which will be tested later on by performance tests which are defined by the test team.</p>
</blockquote>
<h3 id="safety-requirements">Safety Requirements</h3>
<h5 id="cpnotare100034-major-releases">[CP.NOTAR.E1.00034] Major Releases</h5>
<blockquote>
<p>All used software components MUST use the major releases with Long Term Support. If no LTS is available, all components MUST use the latest major releases with security hardening.</p>
</blockquote>
<h3 id="security-requirements">Security Requirements</h3>
<h5 id="cpnotare100035-cve-patches">[CP.NOTAR.E1.00035] CVE Patches</h5>
<blockquote>
<p>All software components MUST have applied CVE patches, which are available for major releases.</p>
</blockquote>
<h3 id="software-quality-attributes">Software Quality Attributes</h3>
<h5 id="cpnotare100036-software-quality-requirements">[CP.NOTAR.E1.00036] Software Quality Requirements</h5>
<blockquote>
<p>All software components MUST be compliant to the requirements within the quality assurance repository [11]. This includes testing on different layers (unit, component, integration), branch model that support stages, patch management, and code quality verification with adequate reporting. In addition, all requirements and quality attributes MUST demonstrated by automated behavior driven testing [BDD] methodology.</p>
</blockquote>
<h6 id="11-httpsgitlabcomgaia-xdata-infrastructure-federation-servicesquality-assurance-issues">[11] <a href="https://gitlab.com/gaia-x/data-infrastructure-federation-services/quality-assurance/-/issues"><u>[https://gitlab.com/gaia-x/data-infrastructure-federation-services/quality-assurance/-/issues]</u></a></h6>
<h3 id="business-rules">Business Rules</h3>
<h5 id="cpnotare100037-software-consistency">[CP.NOTAR.E1.00037] Software Consistency</h5>
<blockquote>
<p>The used technologies MUST have consistency. Standard technologies e.g., Databases MUST be abstracted over JDBC, authentication over OIDC etc. </p>
</blockquote>
<h5 id="cpnotare100038-cherry-picking">[CP.NOTAR.E1.00038] Cherry Picking</h5>
<blockquote>
<p>All components and the entire software architecture MUST be checked for the necessity for deployment of each single feature, to allow an enterprise deployment customization. </p>
</blockquote>
<h2 id="compliance">Compliance</h2>
<h5 id="cpnotare100039-gdpr-audit-logging">[CP.NOTAR.E1.00039] GDPR Audit Logging</h5>
<blockquote>
<p>All GDPR relevant access to personal relevant data MUST be logged for a later audit.</p>
</blockquote>
<h5 id="cpnotare100040-gdpr-data-processing">[CP.NOTAR.E1.00040] GDPR Data Processing</h5>
<blockquote>
<p>Is it necessary to process person-relevant data, it MUST be earmarked to a clearly defined business process, which has to be described in the GDPR design decisions. All relevant data MUST be deleted after the processing, if applicable. </p>
</blockquote>
<h2 id="design-and-implementation">Design and Implementation</h2>
<h3 id="installation">Installation</h3>
<h5 id="cpnotare100041-helmargo-cd-deployment">[CP.NOTAR.E1.00041] Helm/Argo CD Deployment</h5>
<blockquote>
<p>All installations MUST be scripted/templated to ensure automated deployment. This MUST be ensured over HELM templates which MUST follow uniform rules across all lots. The charts MUST be integrable in a ARGO CD Pipeline defined in the integration repository [12].</p>
</blockquote>
<h6 id="12-httpsgitlabeclipseorgeclipsexfscintegration">[12] <a href="https://gitlab.eclipse.org/eclipse/xfsc/integration"><u>[https://gitlab.eclipse.org/eclipse/xfsc/integration]</u></a></h6>
<h3 id="configuration">Configuration</h3>
<h5 id="cpnotare100042-configuration">[CP.NOTAR.E1.00042] Configuration</h5>
<blockquote>
<p>All components MUST support one of the major configuration formats (yaml, Json, ini, environment variables) wherever configuration is required. If environment variables are overwriting an actively set configuration, a warning SHOULD be logged. </p>
</blockquote>
<h3 id="distribution">Distribution</h3>
<h5 id="cpnotare100043-helm-repositories">[CP.NOTAR.E1.00043] Helm Repositories</h5>
<blockquote>
<p>All component helm charts MUST be available under a helm repository hosted in the GitLab, with different channels for distribution [13].</p>
</blockquote>
<h6 id="13-httpsgitlabcomapiv4projects41175300packageshelmintegrationindexyaml">[13] <a href="https://gitlab.com/api/v4/projects/41175300/packages/helm/Integration/index.yaml"><u>[https://gitlab.com/api/v4/projects/41175300/packages/helm/Integration/index.yaml]</u></a></h6>
<h5 id="cpnotare100044-istio-resources">[CP.NOTAR.E1.00044] Istio Resources</h5>
<blockquote>
<p>Additionally, the Charts MUST provide Istio Resource (eg., Authorization Rules, Virtual Services []{#3.5.4_Service_Meshing .anchor}etc.) following the integration pattern specified in the gxfs-integration repo [14].</p>
</blockquote>
<h6 id="14-httpsgitlabeclipseorgeclipsexfscintegration">[14] <a href="https://gitlab.eclipse.org/eclipse/xfsc/integration"><u>[https://gitlab.eclipse.org/eclipse/xfsc/integration]</u></a></h6>
<h3 id="service-meshing">Service Meshing</h3>
<h5 id="cpnotare100045-istio-support">[CP.NOTAR.E1.00045] Istio Support</h5>
<blockquote>
<p>All HELM charts MUST be provided with Istio support aligned together with the project team. This consists of Authorization Rules, Virtual Service Definitions and other relevant Istio Definitions which are required for integration in a Istio Environment.</p>
</blockquote>
<h3 id="standard-technology">Standard Technology</h3>
<h5 id="cpnotare100046-default-toolstack">[CP.NOTAR.E1.00046] Default Toolstack</h5>
<blockquote>
<p>Each development MUST consider the following standard technologies if nothing else is explicitly requested:</p>
</blockquote>
<table>
<thead>
<tr>
<th>Area</th>
<th>Technology</th>
</tr>
</thead>
<tbody>
<tr>
<td>Service Meshing</td>
<td>Istio</td>
</tr>
<tr>
<td>Databases</td>
<td>Redis, Mongo, Postgres</td>
</tr>
<tr>
<td>Messaging</td>
<td>CloudEvents</td>
</tr>
<tr>
<td>Continuous Integration</td>
<td>Argo CD, Gitlab</td>
</tr>
<tr>
<td>Installation Templates</td>
<td>HELM</td>
</tr>
<tr>
<td>Container</td>
<td>Docker Images (ARM64/AMD64)</td>
</tr>
<tr>
<td>Secret Storage</td>
<td>Hashicorp Vault, k8s Secret</td>
</tr>
<tr>
<td>UI Technology</td>
<td>React [15]</td>
</tr>
<tr>
<td>Ingress Controller</td>
<td>Nginx</td>
</tr>
<tr>
<td>API Testing</td>
<td>Postman (manual)</td>
</tr>
<tr>
<td>Kubernetes</td>
<td>1.26+</td>
</tr>
<tr>
<td>API Design</td>
<td>OpenAPI</td>
</tr>
<tr>
<td></td>
<td></td>
</tr>
</tbody>
</table>
<blockquote>
<h6 id="table-3-technology-stack">Table 3: Technology Stack</h6>
</blockquote>
<p>###### [15] <a href="https://react-bootstrap.github.io/"><u>[https://react-bootstrap.github.io/]</u></a></p>
<hr />
<blockquote>
<p><img alt="" src="../media/image2.png" /> </p>
<p>The technology stack is mandatory to avoid integration impact.</p>
</blockquote>
<hr />
<h3 id="metrics">Metrics</h3>
<h5 id="cpnotare100047-open-telemetry-support">[CP.NOTAR.E1.00047] Open Telemetry Support</h5>
<blockquote>
<p>All helm charts/services MUST provide metrics endpoints in opentelemetry [16] format.</p>
</blockquote>
<h6 id="16-httpsopentelemetryiodocs">[16] <a href="https://opentelemetry.io/docs/"><u>[https://opentelemetry.io/docs/]</u></a></h6>
<h3 id="configurability">Configurability</h3>
<h5 id="cpnotare100048-configuration-profiles">[CP.NOTAR.E1.00048] Configuration Profiles</h5>
<blockquote>
<p>Environment specific parameters MUST be configurable over the helm templates by using profiles. Each component MUST be delivered minimum for profile:</p>
</blockquote>
<ul>
<li>
<p>DEV, a local environment for round trip development and testing</p>
</li>
<li>
<p>Acceptance, a restricted resource environment (with minimal system requirements) which can be deployed in cluster (remote or locally)</p>
</li>
<li>
<p>Prod, a scalable environment with fault tolerance, HA settings and security hardening</p>
</li>
</ul>
<h5 id="cpnotare100049-secret-references-in-helm-charts">[CP.NOTAR.E1.00049] Secret References in Helm Charts</h5>
<blockquote>
<p>The configuration secrets within Helm Charts MUST use secretRefs to support external []{#3.5.8_Maintainability .anchor}Secretmanagement. Clear text secrets within the Helm Charts are not allowed.</p>
</blockquote>
<h3 id="maintainability">Maintainability</h3>
<h5 id="cpnotare100050-micro-service-architecture">[CP.NOTAR.E1.00050] Micro Service Architecture</h5>
<blockquote>
<p>For a better scale out, maintainability and decentralization, the product architecture MUST have a micro service architecture. Each microservice MUST NOT be limited on the lines of code or number of days to implement it. The service "size" SHOULD be oriented on the fine granular business capabilities. (e.g., Order, ListMenu, Payment).</p>
</blockquote>
<h5 id="cpnotare100051-domain-driven-design">[CP.NOTAR.E1.00051] Domain Driven Design</h5>
<blockquote>
<p>To support the micro service architecture within the maintainability, it MUST be declared a domain model before realization. The software description MUST explain which domain model was chosen, which services contain it and how it scales. This MUST be documented in the public code repository to support future enhancements for new developers.</p>
</blockquote>
<h3 id="reusability">Reusability</h3>
<h5 id="cpnotare100052-enterprise-environments">[CP.NOTAR.E1.00052] Enterprise Environments</h5>
<blockquote>
<p>All components MUST be reusable in different enterprise environments by customization and white labeling. Means all components MUST be able to customize and white label the components by configuration settings (e.g., UIs, text labels, endpoints etc.)</p>
</blockquote>
<h3 id="runtime-stability">Runtime Stability</h3>
<h5 id="cpnotare100053-readiness-checkups">[CP.NOTAR.E1.00053] Readiness Checkups</h5>
<blockquote>
<p>All components MUST reflect after bootstrap and during runtime the correctness of the service functionality by reflecting it over health endpoints. The health endpoint MUST return failure (red), if any internal behavior failure or misconfiguration occurs (not just the software running state). This means for instance to check continuously during the runtime:</p>
</blockquote>
<ul>
<li>
<p>A unreachable configured Services results in failed state</p>
</li>
<li>
<p>Configured Service Endpoints needs to be checked for readiness during runtime, if not reachable, it results in failure state</p>
</li>
<li>
<p>Check depending components (Database, Microservice etc.) behind it, if not reachable, it results in failed state</p>
</li>
</ul>
<h3 id="high-availability-concepts">High Availability Concepts</h3>
<h5 id="cpnotare100054-redundant-deployment">[CP.NOTAR.E1.00054] Redundant Deployment</h5>
<blockquote>
<p>Each deployment MUST be configured for a minimum fault tolerance of 2 instances.</p>
</blockquote>
<h3 id="proof-of-concept">Proof of Concept</h3>
<h5 id="cpnotare100055-architecture-changes">[CP.NOTAR.E1.00055] Architecture Changes</h5>
<blockquote>
<p>All Architecture Changes MUST be aligned with the Principal before implementation.</p>
</blockquote>
<h1 id="verification">Verification</h1>
<h2 id="core-verification-requirements">Core Verification Requirements</h2>
<blockquote>
<p>All listed verification items/criteria must be fulfilled by a demonstration of the implementation within the provided Kubernetes environment.</p>
</blockquote>
<h5 id="cpnotare100056-kubernetes-deployment">[CP.NOTAR.E1.00056] Kubernetes Deployment</h5>
<blockquote>
<p>If the verification is related to software components, it must be deployed in a Kubernetes test cluster and the components must be deployable in a Kubernetes cluster with automated package manager deployment (e.g., Helm). </p>
</blockquote>
<hr />
<blockquote>
<p><img alt="" src="../media/image2.png" /></p>
<p>Docker Compose and other local systems can be used for local development and testing, but it's NOT allowed for a final acceptance demonstration.</p>
</blockquote>
<hr />
<h2 id="support-for-kubernetes">Support for Kubernetes</h2>
<h5 id="cpnotare100057-eventing">[CP.NOTAR.E1.00057] Eventing</h5>
<blockquote>
<p>All eventings must be demonstrated on basis of cloud events specifications [CloudEvents] together with the kNative [17] broker in a Kubernetes environment.</p>
</blockquote>
<h6 id="17-httpsknativedevdocseventing">[17] <a href="https://knative.dev/docs/eventing/"><u>[https://knative.dev/docs/eventing/]</u></a></h6>
<h5 id="cpnotare100058-config-map-support">[CP.NOTAR.E1.00058] Config Map Support</h5>
<blockquote>
<p>Each service must be demonstrated up and running in Kubernetes, configured by config maps.</p>
</blockquote>
<h5 id="cpnotare100059-helm-installation">[CP.NOTAR.E1.00059] Helm Installation</h5>
<blockquote>
<p>The service installation MUST be demonstrated during HELM install.</p>
</blockquote>
<h5 id="cpnotare100060-argocd-integration">[CP.NOTAR.E1.00060] ArgoCD Integration</h5>
<blockquote>
<p>The helm chart MUST be able to install inside of ArgoCD. This includes the usage of the postgres hooks [18] and the providing of usable values.yaml(s) for all developed services.</p>
</blockquote>
<h6 id="18-httpsgitlabcomgaia-xdata-infrastructure-federation-servicesgxfs-integration-treemainhelmchartspostgresql-hook">[18] <a href="https://gitlab.com/gaia-x/data-infrastructure-federation-services/gxfs-integration/-/tree/main/helm/charts/postgresql-hook"><u>[https://gitlab.com/gaia-x/data-infrastructure-federation-services/gxfs-integration/-/tree/main/helm/charts/postgresql-hook]</u></a></h6>
<h5 id="cpnotare100061-scs-environment">[CP.NOTAR.E1.00061] SCS Environment</h5>
<blockquote>
<p>All HELM installations MUST run on SCS (Sovereign Cloud Stack). The [final acceptance]{.underline} demonstration cannot be realized on azure, google cloud etc.</p>
</blockquote>
<h2 id="functionality-acceptance-criteria">Functionality Acceptance Criteria</h2>
<blockquote>
<p>Additionally, to the acceptance requirements in the functional description, the following criteria must be considered.</p>
</blockquote>
<h5 id="cpnotare100062-credential-issuance">[CP.NOTAR.E1.00062] Credential Issuance</h5>
<blockquote>
<p>When a DID Document contains multiple Protocols, all of the used wallets contain the issued credential after an notarization.</p>
</blockquote>
<h5 id="cpnotare100063-trustlist-integration">[CP.NOTAR.E1.00063] Trustlist Integration</h5>
<blockquote>
<p>The enrollments MUST be visible over the DNS resolvers and the trustlists MUST be updated with the new notarized items. Additionally, the notarization MUST provide the trust list endpoints and DNS zones per public profile with the notarization DID Document.</p>
</blockquote>
<h5 id="cpnotare100064-decision-engine-integration">[CP.NOTAR.E1.00064] Decision Engine Integration</h5>
<blockquote>
<p>It MUST demonstrate that the notarization API can automatically make decisions for issuing based on OAW and TSA policy outcomes. Note: OAW and TSA MUST be integrated in the demonstration to show the functionality. The environment for these components will be provided by the principal for testing.</p>
</blockquote>
<h1 id="appendix-a-glossary">Appendix A: Glossary</h1>
<blockquote>
<p>For the glossary refer to IDM.AO Glossary/Terminology [IDM.AO].</p>
</blockquote>
<h1 id="appendix-b-architecture">Appendix B: Architecture</h1>
<p><img alt="" src="../media/image4.png" /></p>
              
            </div>
          </div><footer>
    <div class="rst-footer-buttons" role="navigation" aria-label="Footer Navigation">
        <a href="../.." class="btn btn-neutral float-left" title="Index"><span class="icon icon-circle-arrow-left"></span> Previous</a>
        <a href="../../train/train/" class="btn btn-neutral float-right" title="Trust Management Infrastructure">Next <span class="icon icon-circle-arrow-right"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <!-- Copyright etc -->
  </div>

  Built with <a href="https://www.mkdocs.org/">MkDocs</a> using a <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>.
</footer>
          
        </div>
      </div>

    </section>

  </div>

  <div class="rst-versions" role="note" aria-label="Versions">
  <span class="rst-current-version" data-toggle="rst-current-version">
    
    
      <span><a href="../.." style="color: #fcfcfc">&laquo; Previous</a></span>
    
    
      <span><a href="../../train/train/" style="color: #fcfcfc">Next &raquo;</a></span>
    
  </span>
</div>
    <script src="../../js/jquery-3.6.0.min.js"></script>
    <script>var base_url = "../..";</script>
    <script src="../../js/theme_extra.js"></script>
    <script src="../../js/theme.js"></script>
      <script src="../../search/main.js"></script>
    <script>
        jQuery(function () {
            SphinxRtdTheme.Navigation.enable(true);
        });
    </script>

</body>
</html>
